/*|_______________________________________________*/
/*| You burn with us                              */
/*|                     \/                       */
/*|                    ( )                      */
/*|_______________o0o___(_)___o0o_________________*/
#property strict
#import "speak_b6.dll"
bool gSpeak(string text, int rate, int volume);
#import
#property copyright   "Copyright 1838 - 2018, Magnus Richterson."
#property link        "https://www.hybridfield.wordpress.com"

#property description "Created by me :)"
#property description "The original name of the program -You burn with us-"
#property description "------------------------------------------------------------------------------------------------"
#property description "This Tool is coded by Magnus Richterson, aka dino, aka rfb"
#property description "You are able to find me at  Magnus.Richters [ at ] gmail.com"
#property description "Big problem 389 (0) 75 45 00 48"
#property description "All forex symbols trader with priority for"
#property description "------------------------------------------------------------------------------------------------"
#property description "Todo: Make a lot of buttons and wallinfo."
#property strict

#define texts "Terminal"
#define signs "Wingdings"

#define frames_count 3

#define account "3) Percent Account at risk "
#define split   "2) Include from list rang to trade"
#define profit  "1) Take halp scalp profits"
#define trade   "0) Trade"
#define debug   "4) Debug with error messages"

enum CLICK_ACTION {none, CHART_NEW};
enum TYPE_SYMBOL {FOREX, CFD, FUTURES, INDICES};
//---
input TYPE_SYMBOL     symbols_types  = FOREX;         
input bool            only_tradeable = false;
input bool            sort_by_trend  = false;
input bool            only_the_best  = false;
input bool            speak_notices  = false;
input color           bullish_color  = clrAqua;
input color           bearish_color  = clrGold;
input color           text_color     = clrNavy;
input color           common_color   = clrSilver;

CLICK_ACTION button_action  = CHART_NEW;         
int button_height = 15;
int font_size     = 8;
int y_distance = 30;
int x_distance = 10;
string symbols_list[], separ=" | ", cur, days[]={"Sunday","Monday","Tuesday","Wednesday","Thursday","FRIDAY","Saturday"};;
int ranges_list[], profit_list[], tradeable_tf_list[], signals_list[,3], idn, sum_days, sum_hours, bars_counts;
int convert_digits=1, NUM_tframes, NUM_symbols, tframes_list[]={1,5,15,60,240,1440,PERIOD_W1,PERIOD_MN1};
datetime bar_timer;
bool dll, test, demo;
double old_prices_list[], start_balance;

/*--------------------------------------------------------------------------------------------------------*/

int OnInit()
  {
   test          = IsTesting();
   demo          = IsDemo();
   dll           = IsDllsAllowed();
   start_balance = AccountBalance();
   cur           = AccountCurrency();
   NUM_tframes   = ArraySize(tframes_list);
   if ( test ) return(INIT_FAILED);
/* change to Minute 1 chart: */
   ChartSetSymbolPeriod(0,Symbol(),PERIOD_M1);
/* load all tradable simbols by broker and for account also by the input choice: */
   if ( Load_symbols() < 1 ) return(INIT_FAILED);
/* load Global Variables for changes and settings: */
   Load_globals();
/* load only once arrays in use: */
   Load_arrays();
/* create Timer sleep between all functions, for cpus use reduce: */
   bool create = EventSetMillisecondTimer(100);
   if ( !create ) return(INIT_FAILED);
/* for adjust broker difference in digits supply: */
   if ( Digits == 5 || Digits == 3 || Digits == 1 ) convert_digits = 10;
/* create buttons and other for info on screen: */
   Create_objects();
/* check voice info: */
   if( ! speak_notices && dll ) gSpeak( " Am I DONE?", 1, 100 );
/* send charts to background so texts to be infront seen: */
   ChartSetInteger(CHART_MODE,CHART_FOREGROUND,false);
   return(INIT_SUCCEEDED);
  }

/*--------------------------------------------------------------------------------------------------------*/

void OnDeinit(const int reason)  { Comment(""); ObjectsDeleteAll(ChartID()); EventKillTimer();  }

/*--------------------------------------------------------------------------------------------------------*/

void OnTimer()
  {
/* refresh all incomes data: */
   RefreshRates();
/* recalculate after few bars: */
/* average ranges from all timeframes and sort by probable invest/return : */
   if ( bar_timer < Time[5] ) Recalculate_value_moves();
/* send new on market? */
   if( GlobalVariableGet( trade ) > 0 ) New_on_Market();
/* for screen text and signals: */
   Prices_levels();
/* buttons texts for updated info: */
   Buttons_texts();
/* manage opened orders: */
   Take_Profits();
   Protect_Funds();
/* screen info: */
   Screen_texts();
   return;
  }

/*-------------------- chart handling event --------------------------------------------------------------*/

void OnChartEvent( const int id, const long & lparam, const double & dparam, const string & sparam )  {
/* set button preesed for opening the symbol chart: */
   for(int i=0; i<NUM_symbols; i++)  {
      if(sparam==IntegerToString(i))  {
         int index = profit_list[i];
         int chart_frame=tframes_list[tradeable_tf_list[index]];
         string symbol_name=symbols_list[index];
         if(button_action==CHART_NEW)   {
            ObjectSetInteger(0,i,OBJPROP_STATE,false);
            ChartOpen(symbol_name, chart_frame);
      //      ChartSetSymbolPeriod(0,symbol_name,chart_frame);
           }
        }
     }
  }

/*--------------------------------------------------------------------------------------------------------*/

int Load_symbols() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Loading Symbols");  Sleep(2000);  }
   RefreshRates();
   NUM_symbols=0;
   string _check;
   for( int _i = 0; _i < SymbolsTotal( false ); _i ++ ) {
      _check = SymbolName( _i,false );
      /* todo: expand more refined selecting by prefixes -indexes, stocks, comoditties,   */
      if( only_tradeable ) if( MarketInfo( _check,MODE_TRADEALLOWED ) <= 0 ) continue;
      if( symbols_types == 0) {
        if( MathMax( MarketInfo( _check,27 ),MarketInfo( _check,28 ) ) != 0 ) continue;
        if( StringFind( _check,"XAU" ) > -1 || StringFind( _check,"XAG" ) > -1 ) continue;
      }
      if( symbols_types > 0 ) if( MarketInfo( _check,28 ) != symbols_types ) continue;
      NUM_symbols++;
      ArrayResize( symbols_list, NUM_symbols );
      symbols_list[NUM_symbols-1] = _check;
   } 
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Load Symbols finished: ",NUM_symbols);  Sleep(2000);  }
   return( NUM_symbols );
}

/*--------------------------------------------------------------------------------------------------------*/

void Load_arrays() {
   ArrayResize( profit_list, NUM_symbols );
   ArrayResize( ranges_list, NUM_symbols );
   ArrayResize( tradeable_tf_list, NUM_symbols );
   ArrayResize( signals_list, NUM_symbols );
   ArrayResize( old_prices_list, NUM_symbols );
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

void Recalculate_value_moves() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Recalculating Value list");  Sleep(2000);  }
   double _point_value, _sum_points, _lots, _value[], _max_found;
   ArrayResize( _value, NUM_symbols ); 
   ArrayInitialize( _value, 0 );
   ArrayInitialize( ranges_list, 0 );
   
   for( int _x = 0; _x < NUM_symbols; _x ++ ) {
      double point = MarketInfo( symbols_list[_x],MODE_POINT );
      
      for( int _y = NUM_tframes - 1; _y > -1; _y -- ) {
         if(sort_by_trend) _sum_points = MathAbs( rMa( symbols_list[_x],tframes_list[_y],PRICE_OPEN ) - rMa( symbols_list[_x],tframes_list[_y],PRICE_CLOSE ) + point ) / point;
         else _sum_points = ( rMa( symbols_list[_x],tframes_list[_y],PRICE_HIGH ) - rMa( symbols_list[_x],tframes_list[_y],PRICE_LOW ) + point ) / point;
         _sum_points -= MarketInfo( symbols_list[_x],MODE_SPREAD );
         ranges_list[_x] += _sum_points;
         if( _sum_points > 2*MarketInfo( symbols_list[_x],MODE_SPREAD ) ) tradeable_tf_list[_x] = _y;
      }
      if(sort_by_trend) { if( ranges_list[_x] != 0 ) ranges_list[_x] -= ranges_list[_x] / NUM_tframes; }
      else if( ranges_list[_x] != 0 ) ranges_list[_x] /= NUM_tframes;
      _point_value = MarketInfo( symbols_list[_x],MODE_TICKVALUE ) / MarketInfo( symbols_list[_x],MODE_TICKSIZE ) * point;
      _lots = AccountBalance() / MarketInfo( symbols_list[_x],32 );
      _value[_x] = ranges_list[_x] * _point_value * _lots;
   }
   
   int _cnt, counter=0;
   if( only_the_best ) {
     _max_found = 0;
     for ( int _e = 0; _e < NUM_symbols; _e++ )
       if ( _value[_e] > _max_found ) _max_found = _value[_e];
     for ( int _v = 0; _v < NUM_symbols; _v++ )
       if ( _max_found > 2 * _value[_v] ) {
         _value[_v] = -9999;
         counter++;
       }
   }
   
   ArrayInitialize( profit_list, NUM_symbols-1 );
   for( int _z = 0; _z < NUM_symbols; _z ++ ) {
      _max_found = 0;
      _cnt = -1;
      for( int _w = 0; _w < NUM_symbols; _w ++ ) {
         if( _value[_w] > _max_found ) { _max_found = _value[_w]; _cnt = _w; }
      }
      if ( _max_found > 0.0 &&_cnt > -1 ) {
        profit_list[_z] = _cnt;
        _value[_cnt] = -9999;
      }
   }
   bar_timer=Time[0];
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End Value_list");  Sleep(1000);  }
   Comment("From ",NUM_symbols," Symbols,",(NUM_symbols - counter)," sorted first with best chances for best profit");
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

double rMa( string _sym_, int _tf_, int _price_mode) { return( iMA( _sym_, _tf_,20,0,2,_price_mode,1 ) ); }

/*--------------------------------------------------------------------------------------------------------*/

void Prices_levels() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Start Price levels");  Sleep(1000);  }
   ArrayInitialize(signals_list, 2);
   for( int p = 0; p < NUM_symbols; p ++ ) {
     bool up=true, down=true; 
     int counter=0, min=tradeable_tf_list[p], max=MathMin(tradeable_tf_list[p]+frames_count,NUM_tframes);
     for( int d = min; d < max; d ++ ) {
       //if ( tradeable_tf_list[p] < d ) continue;
       if ( counter > frames_count-1 ) continue;
       double sig0 = iMACD(symbols_list[p],tframes_list[d],1,2,1,PRICE_TYPICAL,MODE_MAIN,0);
       double sig1 = iMACD(symbols_list[p],tframes_list[d],1,2,1,PRICE_TYPICAL,MODE_MAIN,1);
       if ( sig0>sig1 && sig0>0.0 ) signals_list[p,counter] = 0;
       if ( sig0<sig1 && sig0<0.0 ) signals_list[p,counter] = 1;
       counter++;
     }
   }
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End Price levels");  Sleep(1000);  }
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

void Create_objects() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Creating objects");  Sleep(1000);  }
   Form_objects( 0, x_distance, 160 );
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End objects");  Sleep(1000);  }
}

/*--------------------------------------------------------------------------------------------------------*/

void Form_objects(int name, int begin, int lenght, string font=texts) {
   for(int i=name; i<NUM_symbols+name; i++)  {
      int y_dist = y_distance+(button_height*i);
      int x_dist = x_distance+begin;
      ObjectCreate(0,i,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,i,OBJPROP_CORNER,0);
      ObjectSetInteger(0,i,OBJPROP_XDISTANCE,x_dist);
      ObjectSetInteger(0,i,OBJPROP_YDISTANCE,y_dist);
      ObjectSetInteger(0,i,OBJPROP_XSIZE,lenght);
      ObjectSetInteger(0,i,OBJPROP_YSIZE,button_height);
      ObjectSetInteger(0,i,OBJPROP_FONTSIZE,font_size);
      ObjectSetInteger(0,i,OBJPROP_COLOR,text_color);
      ObjectSetInteger(0,i,OBJPROP_BGCOLOR,common_color);
      ObjectSetInteger(0,i,OBJPROP_BACK,false);
      ObjectSetInteger(0,i,OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,i,OBJPROP_SELECTED,false);
      ObjectSetInteger(0,i,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,i,OBJPROP_ZORDER,0);
      ObjectSetInteger(0,i,OBJPROP_STATE,false);
      ObjectSetString(0,i,OBJPROP_FONT,font);
      ObjectSetString(0,i,OBJPROP_TEXT,"");
   }
}

/*--------------------------------------------------------------------------------------------------------*/

void Buttons_texts() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Updating buttons texts");  Sleep(1000);  }
   for(int i=0; i<NUM_symbols; i++)     {
   
      int index=profit_list[i];
      string symbol_name=symbols_list[index];
      string signal="";
      int counter=0;
      
      for(int s=0;s<NUM_tframes; s++) {
      
        if(tradeable_tf_list[s] < s) continue;
        counter++;
        if(counter>3) continue;
        if(signals_list[index,s]==0) signal=signal+CharToString(0x318);
        else if(signals_list[index,s]==1) signal=signal+CharToString(0x319);
        else signal=signal+"-";
      }
      
      double point= MarketInfo(symbol_name,MODE_POINT);
      double past_range=NormalizeDouble(ranges_list[index]*point/iOpen( symbol_name,1440,0 )/point/100/convert_digits,2);
      string string_range = DoubleToStr(past_range,2);

      color button_color = bearish_color;
      if(past_range>=0.5) button_color = bullish_color;
      
      string button_text=symbol_name+separ+string_range+"%"+separ+tradeable_tf_list[index]+separ+signal;
      
      ObjectSetInteger(0,i,OBJPROP_BGCOLOR,button_color);
      ObjectSetString(0,i,OBJPROP_TEXT,button_text);
     }
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End buttons texts");  Sleep(1000);  }
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

void Load_globals() {
   if( ! GlobalVariableCheck( account ) ) GlobalVariableSet( account, 10 );
   if( ! GlobalVariableCheck( split ) ) GlobalVariableSet( split, 1 );
   if( ! GlobalVariableCheck( trade ) ) GlobalVariableSet( trade, 0 );
   if( ! GlobalVariableCheck( debug ) ) GlobalVariableSet( debug, 1 );
   if( ! GlobalVariableCheck( profit ) ) GlobalVariableSet( profit, 1 );
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

void New_on_Market() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Sending new orders");  Sleep(1000); }
   /*  REMOVED CODE  */
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End new orders");  Sleep(1000); }
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

bool checkFree( int _srch_symbol, int _srch_ord_typ ) {
   for( int _x = OrdersTotal() - 1; _x >= 0; _x -- ) {
      if( !OrderSelect( _x,SELECT_BY_POS ) ) continue;
      if( OrderType() == _srch_ord_typ && OrderSymbol() == profit_list[_srch_symbol] ) return( false );
   }
   return( true );
}

/*--------------------------------------------------------------------------------------------------------*/

void Take_Profits() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Start take profits");  Sleep(1000); }
   /*  REMOVED CODE  */
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End take profits");  Sleep(1000); }
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

void Protect_Funds() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Start Protect trades");  Sleep(1000); }
   /*  REMOVED CODE  */
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End protect");  Sleep(1000); }
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

double lots( int _index_symbol ) {
   if( GlobalVariableGet( account ) <= 0 ) return( MarketInfo( profit_list[_index_symbol],MODE_MINLOT ) );
   double _total_lots = AccountFreeMargin() / MarketInfo( profit_list[_index_symbol],32 );
   _total_lots = _total_lots / 100 * GlobalVariableGet( account ) / MathMax( _index_symbol,GlobalVariableGet( split ) );
   if( _total_lots < MarketInfo( profit_list[_index_symbol],MODE_MINLOT ) ) {
     if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Error, ruined account");  Sleep(1000); }
     if ( speak_notices && dll ) gSpeak( " Account CHECK. Problem.", 1, 100 ); 
     return( 0 );
   }
   return( PartLot( profit_list[_index_symbol], _total_lots ) );
}

/*--------------------------------------------------------------------------------------------------------*/

double PartLot( string _full_symbol, double plot ) {
   int rounded = plot / MarketInfo( _full_symbol,MODE_LOTSTEP );
   return( MathMax( MarketInfo( _full_symbol,MODE_MINLOT ), MathMin( rounded * MarketInfo( _full_symbol,MODE_LOTSTEP ), MarketInfo( _full_symbol,MODE_MAXLOT ) ) ) );
}

/*--------------------------------------------------------------------------------------------------------*/

void Screen_texts() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Screen info texts");  Sleep(1000); }
   /*  REMOVED CODE  */
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End screen info");  Sleep(1000); }
   return;
}

/*--------------------------------------------------------------------------------------------------------*/

double LastTrade(){
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Checking history");  Sleep(1000); }
   for ( int h = OrdersHistoryTotal()-1; h >= 0; h -- ) {
     if ( !OrderSelect( h,SELECT_BY_POS, MODE_HISTORY ) ) continue;
     if ( OrderMagicNumber() != idn ) continue;
     if ( OrderType() != OP_BUY && OrderType() != OP_SELL ) continue;
   /*  REMOVED CODE  */
   }
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End history check");  Sleep(1000); }
   return( 0 );
}  

/*--------------------------------------------------------------------------------------------------------*/

void Reject_wrong_indications() {
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" Reject orders decissions");  Sleep(1000); }
   /*  REMOVED CODE  */
   if( GlobalVariableGet( debug ) > 0 ) {  Comment(" End checking maths");  Sleep(1000); }
   return;
}

/*--------------------------------------------------------------------------------------------------------*/
